#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>



/* UART port */
int uart;


/*
** Setup the UART.
*/
uint8_t
uart_init ( char *argv )
{
  /* open port */
  if( (uart = open(argv, O_RDWR | O_NOCTTY) ) <0 ) {
    printf("error: failed to open port\n");
    return 1;
  }

  return 0;
}



/*
** Receive a byte from the UART.
** RETURN: 0 - pass
**         1 - fail
*/
uint8_t
uart_rx ( uint8_t *val )
{
    /* read single byte from port and unstuff */
  if( read(uart, val, 1) > 0 )
    return 0;

  return 1;
}



/*
** Transmit a byte out of the UART.
** RETURN: 0 - pass
**         1 - fail
*/
uint8_t
uart_tx ( uint8_t val )
{
  if( write(uart, &val, 1) > 0 )
    return 0;

  return 1;
}
